'' Sannaj's Link-List libary

'' This offers a C-style Single Linked-List macro

' Macro to declare a list (prototyping eveything)
#macro _declare_single_link_list (_sllist_datatype)
    
    'Setup record (must only be done once during the hole programm setup)
    #ifndef _sllist_datatype##_sllistt
        type _sllist_datatype##_sllistt
            value as _sllist_datatype
            #ifdef _sllist_sozial
                parentcount as byte = 1
            #endif
            nextEL as _sllist_datatype##_sllistt ptr = 0
        end type
    
    namespace _sllist_datatype##_sllist
        #if 0
        '#ifndef _sllist_datatype##_sllist##.element
            :type element as _sllist_datatype##_sllistt
        #endif
        
        
        extern voidVal as _sllist_datatype
		
        ' Add and remove at the begin of the list
        declare function push(byref list as _sllist_datatype##_sllistt ptr, value as _sllist_datatype) as integer
        declare function pop(byref list as _sllist_datatype##_sllistt ptr) as _sllist_datatype
        ' Access first element without efection the structure
        declare function update(byref list as _sllist_datatype##_sllistt ptr, value as _sllist_datatype, index as integer) as integer
        declare function fetch(byref list as _sllist_datatype##_sllistt ptr, index as integer) as _sllist_datatype
        ' Add and remove at the end of the list
        declare function push_under(byref list as _sllist_datatype##_sllistt ptr, value as _sllist_datatype) as integer
        declare function pop_under(byref list as _sllist_datatype##_sllistt ptr) as _sllist_datatype
        ' Add and remove at any prosition of the list
        declare function add overload (byref list as _sllist_datatype##_sllistt ptr, value as _sllist_datatype, index as integer) as integer
        declare function remove overload (byref list as _sllist_datatype##_sllistt ptr, index as integer) as _sllist_datatype
		' Get Pointer to this elemts of the list
        declare function getPtr(byref list as _sllist_datatype##_sllistt ptr, index as integer) as _sllist_datatype##_sllistt ptr
		declare function getLast(elptr as _sllist_datatype##_sllistt ptr) as _sllist_datatype##_sllistt ptr
        ' Add and remove at the pointed prosition within the list.
		declare function add(elptr as _sllist_datatype##_sllistt ptr, value as _sllist_datatype) as integer
		declare function remove(byval firstEL as _sllist_datatype##_sllistt ptr, elptr as _sllist_datatype##_sllistt ptr) as _sllist_datatype
        
    end namespace
    
    #endif
#endmacro

' Macro to define a list (writing all subs)
#macro _define_single_link_list (_sllist_datatype)
    _declare_single_link_list(_sllist_datatype)
    
    namespace _sllist_datatype##_sllist
		
        ' Since we don't know witch value is the right one to choos for returning an error, we declare a emty instance for that.
        #ifdef _sllist_voidVal
			dim shared as _sllist_datatype voidVal = _sllist_voidVal
		#else
			dim shared as _sllist_datatype voidVal		' Leeres Element
		#endif
        
        function push(byref list as _sllist_datatype##_sllistt ptr, value as _sllist_datatype) as integer
            var newEL = new _sllist_datatype##_sllistt   ' Element erstellen
            if newEL = 0 then return -1
            newEL->value = value                        ' Wert laden
            newEL->nextEL = list                        ' Element abhngen.
            list = newEL                                ' Listenzeiger anpassen.
            return 0
        end function
        
        function pop(byref list as _sllist_datatype##_sllistt ptr) as _sllist_datatype
            if list = 0 then return voidVal
            var firstEL = list
            var retVal = firstEL->value                 ' Get value
            list = firstEL->nextEL                      ' Remove from list
            delete firstEL                             	' and destroy it.
            return retVal
        end function
        
        function update(byref list as _sllist_datatype##_sllistt ptr, value as _sllist_datatype, _
        index as integer) as integer
            dim as integer i
            if list = 0 then return -1
            var selEL = list
            for i = 0 to index - 1
                if selEL->nextEL = 0 then exit for
                selEL = selEL->nextEL
            next i
            selEL->value = value
            return 0
        end function
        
        function fetch(byref list as _sllist_datatype##_sllistt ptr, index as integer) as _sllist_datatype
            dim as integer i
            if list = 0 then return voidVal
            var selEL = list
            for i = 0 to index - 1
                if selEL->nextEL = 0 then exit for
                selEL = selEL->nextEL
            next i
            return selEL->value
        end function
        
        function push_under(byref list as _sllist_datatype##_sllistt ptr, value as _sllist_datatype) as integer
            var newEL = list
            if list = 0 then
                list = new _sllist_datatype##_sllistt
                if list = 0 then return -1
                list->value = value                ' Wert laden
                return 0
            else
                while newEL->nextEL <> 0                    ' Zum Ende der Liste fahren
                    newEL = newEL->nextEL
                wend
                newEL->nextEL = new _sllist_datatype##_sllistt      ' Element erstellen
                if newEL->nextEL = 0 then return -1
                newEL->nextEL->value = value                    ' Wert laden
                return 0
            end if
        end function
    
        function pop_under(byref list as _sllist_datatype##_sllistt ptr) as _sllist_datatype
            if list = 0 then return voidVal
            var selEL = list
            dim retVal as _sllist_datatype
            if selEL->nextEL = 0 then                   ' Sonderfall: Nur ein Element in der Liste
                list = 0                                ' Element aushngen.
                retVal = selEL->value               	' Inhalt auslesen.
                delete selEL                            ' Und weg mit dem Element
            else
                while selEL->nextEL->nextEL <> 0        ' Zum vorletzten Element der Liste fahren.
                    selEL = selEL->nextEL
                wend
                retVal = selEL->nextEL->value           ' Inhalt auslesen.
                delete selEL->nextEL                    ' Und weg mit dem Element
                selEL->nextEL = 0                       ' Und den zugehrigen Pointer auf 0 setzten.
            end if
            return retVal
        end function            
            
        function add overload (byref list as _sllist_datatype##_sllistt ptr, value as _sllist_datatype, index as integer) as integer
            dim as integer i
            if list = 0 then return -1
            var selEL = list
            for i = 0 to index - 1
                if selEL->nextEL = 0 then exit for
                selEL = selEL->nextEL
            next i
            var newEL = new _sllist_datatype##_sllistt   ' Element erstellen
            newEL->value = value                        ' Wert laden.
            newEL->nextEL = selEL->nextEL               ' Nach hinten verknpfen
            selEL->nextEL = newEL                       ' Nach vorne verknpfen
            return 0
        end function
        
        function remove overload (byref list as _sllist_datatype##_sllistt ptr, index as integer) as _sllist_datatype
        ' ->0->1->Test/2
			if list = 0 then return voidVal
			if index = 1 then return pop(list)
			if list->nextEl = 0 then return voidVal				
			var selEl = list
			dim as integer i
			for i = 0 to index - 2						' select Target with selEL->nextEL
				if selEL->nextEL->nextEL = 0 then exit for
                selEL = selEL->nextEL
			next
			var remEL = selEL->nextEL					' feth selectet el
			selEL->nextEL = remEL->nextEL				' Disconnect
			var retVal = remEL->value					' Get value
			delete remEL								' And destroy
			return retVal
		end function
		
		function getPtr(byref list as _sllist_datatype##_sllistt ptr, index as integer _
		) as _sllist_datatype##_sllistt ptr
			dim as integer i
			var retptr = list
			for i = 0 to index - 1
				retptr = retptr->nextEL
			next i
			return retptr
		end function
		
		function getLast(elptr as _sllist_datatype##_sllistt ptr) as _sllist_datatype##_sllistt ptr
			if elptr = 0 then return 0
			while elptr->nextEL <> 0
                elptr = elptr->nextEL
            wend
		end function
		
		function add(elptr as _sllist_datatype##_sllistt ptr, value as _sllist_datatype) as integer
			if elptr = 0 then return -1
			var nextEL = elptr->nextEL
			elptr->nextEL = new _sllist_datatype##_sllistt
            if elptr->nextEL = 0 then return -1
			elptr = elptr->nextEL
			elptr->nextEL = nextEL
			elptr->value = value
			return 0
		end function
		
		function remove(byval firstEL as _sllist_datatype##_sllistt ptr, elptr as _sllist_datatype##_sllistt ptr) as _sllist_datatype
			while firstEL->nextEL <> elptr
				if firstEL->nextEL = 0 then return voidVal
				firstEL = firstEL->nextEL
			wend
			firstEL->nextEL = elptr->nextEL	' Unconect element.
			var retVal = elptr->value
			delete elptr
			return retVal
		end function
    end namespace
    '#undef _sllist_v_size
#endmacro


