'' SEPLAC (SANNAJ'S EXAMPLE PROGRAMMING LANGUAGE TO ASSEMBLY COMPILER)
'' FREEBASIC_WRITTEN COMPILER PROF OF CONCEPT

''' seplac.bi - Various declarations for seplac


#define SEPLAC_VERSION "0.1"

#ifndef false
	#define false 0
	#define true  -1
#endif

#ifndef EOL
	#ifdef __FB_WIN32__
		#define EOL chr(13, 10)
	#elseif defined(__FB_LINUX__)
		#define EOL chr(10)
	#else
		#ERROR Platform not supported.
	#endif
#endif

#ifndef false
	#define false 0
	#define true  -1
#endif

#ifndef AS_EXE
	#ifdef __FB_WIN32__
		#define AS_EXE "as.exe"
	#elseif defined(__FB_LINUX__)
		#define AS_EXE "as"
	#else
		#ERROR Platform not supported.
	#endif
#endif

#ifndef LD_EXE
	#ifdef __FB_WIN32__
		#define LD_EXE "ld.exe"
	#elseif defined(__FB_LINUX__)
		#define LD_EXE "ld"
	#else
		#ERROR Platform not supported.
	#endif
#endif

#ifndef EXECUTABLE_ENDING
    #ifdef __FB_WIN32__
		#define EXECUTABLE_ENDING ".exe"
	#elseif defined(__FB_LINUX__)
		#define EXECUTABLE_ENDING ""
	#else
		#ERROR Platform not supported.
	#endif
#endif

#ifndef RuntimeLibName
    #ifdef __FB_WIN32__
		#define RuntimeLibName exepath & "/libseplac-runtimeWin.a"
	#elseif defined(__FB_LINUX__)
		#define RuntimeLibName exepath & "/libseplac-runtimeLinux.a"
	#else
		#ERROR Platform not supported.
	#endif
#endif

#ifndef printIfFlag
	#define printIfFlag(Flag) if compileControlFlag. Flag then print
#endif



#define NULL 0

'-------------------------------------------------------------------------------

enum	' Posible Output Filetypes
	outType_Exe
	outType_Obj
	outType_Asm
    
    outType_Max
end enum

type compileControlFlagType
    outType : 2 as byte = outType_Exe
    verbose : 1 as byte = false
    noClean : 1 as byte = false
end type

'-------------------------------------------------------------------------------

enum	' Compilation errors codes
    NO_ERROR = 0
	error_UNDEFIND_ERROR
    error_INVALID_CMD_ARG
	error_UNEXISTING_INPUT_FILE
    error_OPENING_ERROR
    error_UNCLOSED_STRINGLITERAL
    error_INVALID_TOLKEN
    error_UNEXPECTET_VARIABLE
    error_UNEXPECTET_KEYWORD
    error_UNEXPECTET_OP
    error_UNEXPECTET_NUM
    error_UNEXPECTET_STRING
    error_INTERNAL_VARIOUS
    error_INTERNAL_MALLOC
    error_HELPER_PROGRAM_ABORT
    
    error_Max
end enum

enum
    lexState_ROOT
    lexState_LABEL
    lexState_DOCU
    lexState_STRING
    lexState_SKIPP
    
    lexState_Max
end enum

enum ' Tolkentypes
    toltype_UNKNOWN
    toltype_INVALID = toltype_UNKNOWN
    toltype_VARIABLE
    toltype_KEYWORD
    toltype_OPERATOR
    toltype_NUMBER
    toltype_STRINGLITERAL
    
    toltype_Max
end enum

' Seplac main specific header
declare sub print_error(filename as string = "", linenum as uinteger = 0, errornum as integer, description as string)
declare function seplac_main() as integer

' Global Variables
extern as compileControlFlagType compileControlFlag
extern as string inputFile
extern as integer linecount
