'' SEPLAC (SANNAJ'S EXAMPLE PROGRAMMING LANGUAGE TO ASSEMBLY COMPILER)
'' FREEBASIC_WRITTEN COMPILER PROF OF CONCEPT

''' seplac-emitter.bas - final Assemcode Generator

#include once "inc/seplac-symtab.bi"
#include once "inc/seplac.bi"

function debugOpcodeDecoder(opcode as integer) as string
	select case opcode
	case bcopc_invalid
		return "invalid"
	case bcopc_mov2 ' x0 = x1
		return "mov2"
	case bcopc_add3 ' x0 = x1 + x2
		return "add3"
	case bcopc_add2 ' x0 += x1
		return "add2"
	case bcopc_sub3 ' x0 = x1 - x2
		return "sub3"
	case bcopc_sub2 ' x0 -= x1
		return "sub2"
	case bcopc_mul3
		return "mul3"
	case bcopc_mul2
		return "mul2"
	case bcopc_div3
		return "div3"
	case bcopc_div2
		return "div2"
	case bcopc_pri0 ' Print var0
		return "pri0"
	case bcopc_sci0 ' Get Data into var0
		return "sci0"
	case bcopc_prs1 ' Print string
		return "prs1"
	case else
		return "unknovn"
	end select
end function

' Header for x86-32:

function emitToFile(filename as string) as integer
    '#error Fix  Emition of immidiates.
    dim localSymbolNames(1) as string
    dim aoutF as integer = any
    
    ' Step   I: Open file.
    aoutF = freefile()
    open filename for output as #aoutF
    
    if err <> 0 then
	    print_error(,,error_OPENING_ERROR, " file couldn't be opened: """ & filename & """")
        close #aoutF
        return error_OPENING_ERROR
    end if
    
    '
    
    ' Step  II: Print header and enviroment setup.
    print #aoutF, !"\t.intel_syntax noprefix" & EOL & EOL;
    print #aoutF, !"\t#" & inputFile  &"' compilation started at ";
    print #aoutF, time & " (SEPLAC " & SEPLAC_VERSION &")" & EOL & EOL;
    
    ' Step III: Emit assembly instructions.
    print #aoutF, !".section .text" & EOL 
    print #aoutF, ".balign 16" & EOL & EOL;
    print #aoutF, !".globl _start" & EOL & "_start:" & EOL
    print #aoutF, ".type _start, @function" & EOL & EOL;
    
    currentInstructionEl = bciSymtable
    while currentInstructionEl <> 0
        with (currentInstructionEl->value)
            select case .bcopcode
            case bcopc_invalid
                close #aoutF
                return error_INTERNAL_VARIOUS
            case bcopc_mov2 ' x0 = x1
                print #aoutF, "mov eax, " & decodeParam(.operantData(1),.operantType(1))
                print #aoutF, "mov " & decodeParam(.operantData(0),-1) & " , eax"
            case bcopc_add3 ' x0 = x1 + x2
                print #aoutF, "mov eax, " & decodeParam(.operantData(1),.operantType(1))
                print #aoutF, "add eax, " & decodeParam(.operantData(2),.operantType(2))
                print #aoutF, "mov " & decodeParam(.operantData(0),-1) & " , eax"
            case bcopc_add2 ' x0 += x1
                print #aoutF, "mov eax, " & decodeParam(.operantData(1),.operantType(1))
                print #aoutF, "add " & decodeParam(.operantData(0),-1) & " , eax"
            case bcopc_sub3 ' x0 = x1 - x2
                print #aoutF, "mov eax, " & decodeParam(.operantData(1),.operantType(1))
                print #aoutF, "sub eax, " & decodeParam(.operantData(2),.operantType(2))
                print #aoutF, "mov " & decodeParam(.operantData(0),-1) & " , eax"
            case bcopc_sub2 ' x0 -= x1
                print #aoutF, "mov eax, " & decodeParam(.operantData(1),.operantType(1))
                print #aoutF, "sub " & decodeParam(.operantData(0),-1) & " , eax"
            case bcopc_mul3
                print #aoutF, "mov eax, " & decodeParam(.operantData(1),.operantType(1))
                print #aoutF, "imul eax, " & decodeParam(.operantData(2),.operantType(2))
                print #aoutF, "mov " & decodeParam(.operantData(0),-1) & " , eax"
            case bcopc_mul2
                print #aoutF, "mov eax, " & decodeParam(.operantData(0),-1)
                print #aoutF, "imul eax, " & decodeParam(.operantData(1),.operantType(1))
                print #aoutF, "mov " & decodeParam(.operantData(0),-1) & " , eax"
            case bcopc_div3
                print #aoutF, "xor edx, edx"
                print #aoutF, "mov eax, " & decodeParam(.operantData(1),.operantType(1))
                print #aoutF, "mov ecx, " & decodeParam(.operantData(2),.operantType(2))
                print #aoutF, "idiv ecx"
                print #aoutF, "mov " & decodeParam(.operantData(0),-1) & " , eax"
            case bcopc_div2
                print #aoutF, "xor edx, edx"
                print #aoutF, "mov eax, " & decodeParam(.operantData(0),-1)
                print #aoutF, "mov ecx, " & decodeParam(.operantData(1),.operantType(1))
                print #aoutF, "idiv ecx"
                print #aoutF, "mov " & decodeParam(.operantData(0),-1) & " , eax"
            case bcopc_pri0 ' Print stdd
                print #aoutF, "push offset __seplac_stddstore"
                print #aoutF, "call __seplac_printInt"
            case bcopc_sci0 ' Get Data into stdd
                print #aoutF, "push offset __seplac_stddstore"
                print #aoutF, "call __seplac_scanInt"
            case bcopc_prs1 ' Print string
                print #aoutF, "push offset Lt_" & hex(.operantData(0), 4)
                print #aoutF, "call __seplac_printString"
            case else
                print "Internal error occured during compilation: " & "Found invalid bytcode."
                close #aoutF
                return error_INTERNAL_VARIOUS
            end select
            if TablelError <> 0 then
                print "Internal error occured during compilation: " & "Invalid variable ID found."
                close #aoutF
                return error_INTERNAL_VARIOUS
            end if
            currentInstructionEl = currentInstructionEl->nextEL
        end with
        sleep 1
    wend
    print #aoutF, "call __seplac_exitProgram" ' For security resons
    print #aoutF, ".size _start, .-_start"
	print #aoutF, ".balign 16"
    print #aoutF, EOL & !"\t#" & inputFile  & "' compilation compleated at ";
    print #aoutF, time & " (SEPLAC " & SEPLAC_VERSION &")" & EOL;
    
    ' Step  IV: Reserve Space for Variables:
    currentVariableEl = varSymtable
    print #aoutF, EOL & !".section .bss" & EOL;

    while currentVariableEl <> 0
		with (*currentVariableEl)
            print #aoutF, ".balign 4"
            print #aoutF, !"\t .lcomm\t_" & .value & ",4"
            currentVariableEl = .nextEL
        end with
    wend
    
    print #aoutF, ".balign 4"
    print #aoutF, !"\t .lcomm\t__seplac_stddstore,4"
    
    ' Step   V: Incude Strings:
    dim as integer IDCount = 1
    currentStringEl = strSymtable
    print #aoutF, EOL & !".section .rodata" & EOL; ' We do not need modificable strings.
    
    while currentStringEl <> 0
        with (*currentStringEl)
            print #aoutF, ".balign 4"
            print #aoutF, "Lt_" & hex(IDCount, 4) & !":\t.ascii\t""" & .value & "\0"""
            currentStringEl = .nextEL
        end with
        IDCount += 1
    wend
    
    close #aoutF
    return NO_ERROR
end function
