'' SEPLAC (SANNAJ'S EXAMPLE PROGRAMMING LANGUAGE TO ASSEMBLY COMPILER)
'' FREEBASIC_WRITTEN COMPILER PROF OF CONCEPT

''' seplac-symtab.bas - the string and variable symtable

#include once "inc/seplac.bi"               ' Global Header
#include once "inc/seplac-symtab.bi"        ' Header for symtable
#include once "inc/SingleLinkedList.bas"    ' Link List Support

_define_single_link_list (bcInstr)		' Symbol Table for Bytecode Instructions
'_define_single_link_list (sym_var)	    ' Symbol Table for variables
_define_single_link_list (string)	    ' Symbol Table for string constants


dim shared bciSymtable as bcInstr_sllistt ptr = 0
dim shared varSymtable as string_sllistt ptr = 0
dim shared strSymtable as string_sllistt ptr = 0

dim shared currentInstructionEl as bcInstr_sllistt ptr = 0
dim shared currentVariableEl as string_sllistt ptr = 0
dim shared currentStringEl as string_sllistt ptr = 0

dim shared selectedInstruction as bcInstr ptr = 0
dim shared TablelError as integer = 0

' This function manages the variable symtable. It returns variables indes
function getVarID(label as string, initvalue as integer = 0) as integer ' Returns index
    if varSymtable = 0 then                     ' First entry needs special treadment.
        if string_sllist.push(varSymtable, label) then return 0
        return 1
    else
        ' First test whether this variable allready exists.
        dim as integer index = 1                    ' We start with Index One
        var listPtr = varSymtable
        do                                          ' We need to check entries as long as thair are any
            if listptr->value = label then 
                return index                        ' Variable entry found: Return index and quit function
            else                                    ' Entry found: Try next
                index += 1
                if listptr->nextEL = 0 then exit do
                listptr = listptr->nextEL
            end if
        loop
        if string_sllist.push_under(listptr, label) then return 0            ' Put the new entry into the list.
        return index                                        ' Return its index
    end if
end function

function addBytecodeInstruction() as integer
    if bciSymtable = 0 then
        if bcInstr_sllist.push(bciSymtable, bcInstr_sllist.voidVal) then return -4
        currentInstructionEl = bciSymtable
    else
        if bcInstr_sllist.add(currentInstructionEl, bcInstr_sllist.voidVal) then return -4
        currentInstructionEl = currentInstructionEl->nextEL
    end if
    selectedInstruction = @(currentInstructionEl->value)
    return 0
end function

function addStringTableEntry(strConstant as string) as integer
    if strSymtable = 0 then                     ' First entry needs special treadment.
        if string_sllist.push(strSymtable, strConstant) then return 0
        return 1
    else
        ' First test whether this string symbol allready exists.
        dim as integer index = 1                    ' We start with Index One
        var listPtr = strSymtable
        do                                          ' We need to check entries as long as thair are any
            if listptr->value = strConstant then 
                return index                        ' Variable entry found: Return index and quit function
            else                                    ' Entry found: Try next
                index += 1
                if listptr->nextEL = 0 then exit do
                listptr = listptr->nextEL
            end if
            sleep 1
        loop
        if string_sllist.push_under(listptr, strConstant) then return 0            ' Put the new entry into the list.
        return index                                        ' Return its index
    end if
end function

function decodeParam(ID as integer, pType as byte) as string
    if pType = 0 then
		return str(ID)
    elseif (pType and 1) = 1 then
		if ID = 0 then return "__seplac_stddstore"
		currentVariableEl = varSymtable
		dim as integer i = 1
		while currentVariableEl <> 0
			with (*currentVariableEl)
				if i = ID then
					if pType = -1 then
						return "[_" & .value & "]"
					else
						return "_" & .value
					end if
				end if
				i += 1
				currentVariableEl = .nextEL
				sleep 1
			end with
		wend
	end if
	' If you reach this point, there is no entry with this ID.
	TablelError = error_INTERNAL_VARIOUS
	return "$$INVALID_VARID$$"
    
end function
        
    
