'' SEPLAC (SANNAJ'S EXAMPLE PROGRAMMING LANGUAGE TO ASSEMBLY COMPILER)
'' FREEBASIC_WRITTEN COMPILER PROF OF CONCEPT

''' seplac-pars.bas - seplac - parser & ast-builder


#define parserRoot_distance 20

#include once "inc/seplac.bi"               ' Global Header
#include once "inc/seplac-ast.bi"

' Define StringTable for AST
dim shared AST_stringTable as string
' Define AST Root Point 
dim shared ASTtree as AST_node
dim shared currNode as AST_node ptr
dim shared as zstring ptr STDD = @"stdd"
dim shared currentParser as function(tolkenN as string, tolkenT as integer) as integer _
= @parserRoot()

function decodeTolkenType(tolkenT as integer) as string
	select case tolkenT
    case toltype_INVALID  : return "invalid tolken"
	case toltype_VARIABLE : return "symbol"
	case toltype_KEYWORD  : return "keyword"
	case toltype_OPERATOR : return "operator"
	case toltype_NUMBER   : return "number literal"
	case toltype_STRINGLITERAL : return "string literal"
	case else : return "undefined type nr. " & tolkenT
	end select
end function

function addNode() as AST_node ptr
	var selNode = ASTtree.program.last
	if selNode = NULL then
		selNode = new AST_node
		ASTtree.program.last = selNode
		ASTtree.program.first = selNode
		return selNode
	else
		ASTtree.program.last = new AST_node
		ASTtree.program.last->prevEl = selNode
		selNode->nextEl = ASTtree.program.last
		return ASTtree.program.last
	end if
end function
		

function parserRoot(tolkenN as string, tolkenT as integer) as integer
    ' This is the global parser.
    select case tolkenT
    case toltype_INVALID
		print_error(inputFile, linecount, error_INVALID_TOLKEN, _
		"Invalid Tolken """ & tolkenN & """")
		return 0
	case toltype_VARIABLE
		print "symbol";
		locate ,parserRoot_distance
		print """" & tolkenN & """"
		return 0
	case toltype_KEYWORD
		if tolkenN = "print" then
			currNode = addNode()				' Add a new node for String output.
			currentParser = @parserString
		elseif tolkenN = "EOL" orelse tolkenN = "EOF"
			rem No Operation
		elseif tolkenN = "stdd"
			currNode = addNode()
			currNode->operation.alphaOp = new AST_node
			currNode->operation.alphaOp->prevEL = currNode
			currNode = currNode->operation.alphaOp
			currNode->value.varPtr = STDD		' Var #0 is considered as Standart Output
			currNode->value.varID = 0
			currentParser = @parserVar
		end if
		return 0
	case toltype_OPERATOR
		print_error(inputFile, linecount, error_UNEXPECTET_OP, _
		"Expect instruction or variable found operator: """ & tolkenN & """")
		return -1
	case toltype_NUMBER
		print_error(inputFile, linecount, error_UNEXPECTET_NUM, _
		"Expect instruction or variable found number: """ & tolkenN & """")
		return -1
	case toltype_STRINGLITERAL
		print_error(inputFile, linecount, error_UNEXPECTET_STRING, _
		"Expect instruction or variable found string literal: """ & tolkenN & """")
		return -1
	case else
		print "Internal Error: Undefined Tolkentype";
		print "tolkenT = #" & tolkenT
		print "tolkenN = """ & tolkenN & """"
		return -2
	end select
end function
		

function parserDummy(tolkenN as string, tolkenT as integer) as integer
    ' This is a fake farser to debug lexer.
    select case tolkenT
    case toltype_INVALID
		print "invalid tolken" ;
		locate ,parserRoot_distance
		print ">" & tolkenN & "<"
	case toltype_VARIABLE
		print "symbol";
		locate ,parserRoot_distance
		print """" & tolkenN & """"
	case toltype_KEYWORD
		print "keyword";
		locate ,parserRoot_distance
		print tolkenN
	case toltype_OPERATOR
		print "operator";
		locate ,parserRoot_distance
		print """" & tolkenN & """"
	case toltype_NUMBER
		print "number literal";
		locate ,parserRoot_distance
		print """" & tolkenN & """"
	case toltype_STRINGLITERAL
		print "string literal";
		locate ,parserRoot_distance
		print """" & tolkenN & """"
	case else
		print "toltype_error, ";
		print "undefined type nr. " & tolkenT
	end select
	return 0
end function
